﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using SampleStimulsoft.Models;
using Stimulsoft.Report;

namespace SampleStimulsoft.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [Route("SampleData")]
        public IActionResult SampleData()
        {
            StiReport report = new StiReport();

            var webRootPath = _hostingEnvironment.WebRootPath;
            var reportTrail = $"reports{Path.DirectorySeparatorChar}SampleReport.mrt";
            var reportFilePath = System.IO.Path.Combine(webRootPath, reportTrail);

            var dataTrail = $"reports{Path.DirectorySeparatorChar}data.json";
            var dataFilePath = System.IO.Path.Combine(webRootPath, dataTrail);

            report.Load(reportFilePath);

            return Json(new
            {
                data = System.IO.File.ReadAllText(dataFilePath),
                Template = new
                {
                    ReportFormTemplate = report.SaveToJsonString()
                }
            });
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
